2007-11-19

ubuntu 7.10 下安装 windriver

最近要用Xilinx ISE, 装驱动时老装不上, 去Windriver官网上下的也没用。 configure和make都报错, 自己尝试修改未果。

几经查找, 在http://www.visionlab.uncc.edu/component/option,com_jd-wiki/Itemid,46/上找到解决办法:

首先去ftp://ftp.xilinx.com/pub/utilities/fpga/install_drivers.tar.gz下载并解压最新的驱动, 我下的跟上面那个网站说的一样, md5是d0aea515f1b4523eb2537df86bc6db41

创建一个diff文件

--- install_drivers/linux_drivers/windriver32/windrvr/linux_wrappers.c.orig 2007-03-27 22:35:36.000000000 +0200
+++ install_drivers/linux_drivers/windriver32/windrvr/linux_wrappers.c 2007-09-24 00:32:44.000000000 +0200
@@ -44,9 +44,6 @@
#endif
#include <asm/mman.h>

#include "linux_wrappers.h"
-#if defined(LINUX_26)
- #include <linux/ioctl32.h>

-#endif
#if defined(UDEV_SUPPORT)
#include <linux/devfs_fs_kernel.h>
#endif
@@ -91,7 +88,10 @@
#endif

#if defined(MODULE_LICENSE)
- MODULE_LICENSE("Proprietary");
+ // MODULE_LICENSE("Proprietary");
+ // Uh! Uh! We need to set this to GPL so we can talk to the USB API.
+ // Is it a copyright infringement if I do that for private use??
+ MODULE_LICENSE("GPL");
#endif
#if defined(MODULE_AUTHOR)
MODULE_AUTHOR("Jungo");
@@ -587,7 +587,7 @@
if (!bh)
return NULL;
memset(bh, 0, sizeof(*bh));
- bh->data = data;
+ atomic_long_set(&bh->data, data);
#if defined(LINUX_26)
bh->func = routine;
bh->entry.next = &bh->entry;
@@ -650,7 +650,7 @@
#else
void
#endif
-wrapper_handler(int irq, void *ctx, struct pt_regs *pt)
+wrapper_handler(int irq, void *ctx)
{
struct int_wrapper *context = (struct int_wrapper *)ctx;
int rc = 0;
@@ -1023,7 +1023,7 @@
}

#if defined(WINDRIVER_KERNEL)
- pci_module_init(&generic_pci_driver);
+ pci_register_driver(&generic_pci_driver);
#endif
return 0;
#endif
--- install_drivers/linux_drivers/xpc4drvr2_6/xpc4drvr/Makefile.orig 2007-09-24 00:36:20.000000000 +0200
+++ install_drivers/linux_drivers/xpc4drvr2_6/xpc4drvr/Makefile 2007-09-24 00:36:27.000000000 +0200
@@ -17,7 +17,7 @@
# Run ./configure first, to generate regparm_option
REG_PARM = $(shell grep -c "regparm=3" $(PWD)/regparm_option)
SYM_FILE_DIR = /lib/modules/$(shell uname -r)/build
-GET_USER_SIZE_SYM = $(shell grep -c "get_user_size" $(SYM_FILE_DIR)/Module.symvers)
+GET_USER_SIZE_SYM = 0
ARCH_64BIT = $(shell arch | grep -c "64")
ifeq ($(ARCH_64BIT),1)
CFLAGS += -mcmodel=kernel

保存在源码顶层目录,用patch -p1 < filename打补丁

最后是安装,原文说的是直接运行./install_drivers即可,我这里不行,要进入linux_drivers/windriver32/windrvr
然后运行bash ./configure 和sudo make && sudo make install

那个configure挺诡异的。。。

不过最后终于编译成功了
发表评论